#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + VramRowSize * 1 + 30, "SCORE"); 
    PrintS(Vram + VramRowSize * 4 + 30, "HIGH");
    PrintS(Vram + VramRowSize * 5 + 30, "SCORE"); 
    PrintS(Vram + VramRowSize * 8 + 30, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 9 + 34, CurrentStage + 1);
    PrintS(Vram + VramRowSize * 11 + 30, "TIME");

    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 21 + 30;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            Print2x2(pVram, Char_Remain);
            pVram += 2;
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize * 2 + 30, Score);
    PrintC(pVram, '0');

    pVram = PrintNumber5(Vram + VramRowSize * 6 + 30, HiScore);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 12 + 33, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = Vram + VramRowSize * 19 + 30;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        *pVram = Char_Knife; ++pVram;
        ++i;
        --count;
    }
    while (i != 4) {
        *pVram = Char_Space; ++pVram;
        ++i;
    }
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 11 + 12, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 11 + 13, "TIME UP");
}


static void Print2x2Color(ptr<byte> pVram, byte c, byte color)
{
    Print2x2(pVram + 1, c);
    pVram[0] = color;
    pVram[VramRowSize] = color;
}

void Title()
{
    static const byte[] Colors = {
        Color_White, Color_Magenta, Color_Yellow, Color_Red
    };
    constexpr byte LogoLength = 4;
    constexpr byte LogoWidth = LogoLength * 3;
    constexpr byte LogoX = (30 - LogoWidth) / 2;
    constexpr ptr<byte> LogoPtr = Vram + VramRowSize * 2 + LogoX;

    ClearScreen(); 
    {
        byte c;
        ptr<byte> pVram, pColor;
        c = Char_Title;
        pVram = LogoPtr - 1;
        pColor = Colors;
        repeat(LogoLength) {
            Print2x2Color(pVram, c, *pColor);
            c += 4;
            pVram += 3;
            ++pColor;
        }
    }
    
    Print2x2Color(Vram + VramWidth * 8 + 8, Char_Remain, Color_White);
    Print2x2Color(Vram + VramWidth * 11 + 8, Char_Chaser, Color_Magenta);
    Print2x2Color(Vram + VramWidth * 14 + 8, Char_Disturber, Color_Red);
    Print2x2Color(Vram + VramWidth * 17 + 8, Char_Goal, Color_White);
    
    PrintStatus(); 
    PrintS(Vram + VramWidth * 6 + 7, "--- CHARACTER ---");
    PrintS(Vram + VramWidth * 9 + 13, "MAN");
    PrintS(Vram + VramWidth * 12 + 13, "CHASER");
    PrintS(Vram + VramWidth * 15 + 13, "DISTURBER");
    PrintS(Vram + VramWidth * 18 + 13, "EXIT");

    PrintS(Vram + VramRowSize * 21 + 9, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 22 + 9, "OR RETURN KEY");
}
